/* animation.c generated by valac 0.32.1, the Vala compiler
 * generated from animation.vala, do not modify */

/*
 * Copyright (c) 2013 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define POMODORO_TYPE_ANIMATION_MODE (pomodoro_animation_mode_get_type ())

#define POMODORO_TYPE_ANIMATION (pomodoro_animation_get_type ())
#define POMODORO_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_ANIMATION, PomodoroAnimation))
#define POMODORO_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_ANIMATION, PomodoroAnimationClass))
#define POMODORO_IS_ANIMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_ANIMATION))
#define POMODORO_IS_ANIMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_ANIMATION))
#define POMODORO_ANIMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_ANIMATION, PomodoroAnimationClass))

typedef struct _PomodoroAnimation PomodoroAnimation;
typedef struct _PomodoroAnimationClass PomodoroAnimationClass;
typedef struct _PomodoroAnimationPrivate PomodoroAnimationPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	POMODORO_ANIMATION_MODE_LINEAR,
	POMODORO_ANIMATION_MODE_EASE_IN,
	POMODORO_ANIMATION_MODE_EASE_IN_OUT,
	POMODORO_ANIMATION_MODE_EASE_OUT,
	POMODORO_ANIMATION_MODE_EASE_IN_CUBIC,
	POMODORO_ANIMATION_MODE_EASE_IN_OUT_CUBIC,
	POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC,
	POMODORO_ANIMATION_MODE_BLINK
} PomodoroAnimationMode;

typedef gdouble (*PomodoroAnimationFunc) (gdouble progress, void* user_data);
struct _PomodoroAnimation {
	GInitiallyUnowned parent_instance;
	PomodoroAnimationPrivate * priv;
};

struct _PomodoroAnimationClass {
	GInitiallyUnownedClass parent_class;
};

struct _PomodoroAnimationPrivate {
	GObject* _target;
	gchar* _property_name;
	PomodoroAnimationMode _mode;
	guint _duration;
	guint _frames_per_second;
	gdouble _progress;
	gdouble value_from;
	gdouble value_to;
	gint64 timestamp;
	guint timeout_id;
	PomodoroAnimationFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};


static gpointer pomodoro_animation_parent_class = NULL;

GType pomodoro_animation_mode_get_type (void) G_GNUC_CONST;
GType pomodoro_animation_get_type (void) G_GNUC_CONST;
#define POMODORO_ANIMATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_ANIMATION, PomodoroAnimationPrivate))
enum  {
	POMODORO_ANIMATION_DUMMY_PROPERTY,
	POMODORO_ANIMATION_TARGET,
	POMODORO_ANIMATION_PROPERTY_NAME,
	POMODORO_ANIMATION_MODE,
	POMODORO_ANIMATION_DURATION,
	POMODORO_ANIMATION_FRAMES_PER_SECOND,
	POMODORO_ANIMATION_PROGRESS
};
void pomodoro_animation_stop (PomodoroAnimation* self);
PomodoroAnimation* pomodoro_animation_new (PomodoroAnimationMode mode, guint duration, guint frames_per_second);
PomodoroAnimation* pomodoro_animation_construct (GType object_type, PomodoroAnimationMode mode, guint duration, guint frames_per_second);
static void __lambda5_ (PomodoroAnimation* self);
gdouble pomodoro_animation_get_progress (PomodoroAnimation* self);
static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
void pomodoro_animation_add_property (PomodoroAnimation* self, GObject* target, const gchar* property_name, GValue* property_value);
void pomodoro_animation_set_target (PomodoroAnimation* self, GObject* value);
void pomodoro_animation_set_property_name (PomodoroAnimation* self, const gchar* value);
void pomodoro_animation_start (PomodoroAnimation* self);
GObject* pomodoro_animation_get_target (PomodoroAnimation* self);
const gchar* pomodoro_animation_get_property_name (PomodoroAnimation* self);
static PomodoroAnimationFunc pomodoro_animation_get_func (PomodoroAnimationMode mode, void** result_target, GDestroyNotify* result_target_destroy_notify);
PomodoroAnimationMode pomodoro_animation_get_mode (PomodoroAnimation* self);
guint pomodoro_animation_get_duration (PomodoroAnimation* self);
guint pomodoro_animation_get_frames_per_second (PomodoroAnimation* self);
static gboolean pomodoro_animation_on_timeout (PomodoroAnimation* self);
static void pomodoro_animation_set_progress (PomodoroAnimation* self, gdouble value);
void pomodoro_animation_start_with_value (PomodoroAnimation* self, gdouble value_from);
static gdouble pomodoro_animation_compute_value (PomodoroAnimation* self, gdouble progress);
static gdouble pomodoro_animation_calculate_linear (gdouble t);
static gdouble _pomodoro_animation_calculate_linear_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_in (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_in_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_in_out (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_in_out_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_out (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_out_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_in_cubic (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_in_cubic_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_in_out_cubic (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_in_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_ease_out_cubic (gdouble t);
static gdouble _pomodoro_animation_calculate_ease_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self);
static gdouble pomodoro_animation_calculate_blink (gdouble t);
static gdouble _pomodoro_animation_calculate_blink_pomodoro_animation_func (gdouble progress, gpointer self);
void pomodoro_animation_set_mode (PomodoroAnimation* self, PomodoroAnimationMode value);
void pomodoro_animation_set_duration (PomodoroAnimation* self, guint value);
void pomodoro_animation_set_frames_per_second (PomodoroAnimation* self, guint value);
static void pomodoro_animation_finalize (GObject* obj);
static void _vala_pomodoro_animation_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_animation_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType pomodoro_animation_mode_get_type (void) {
	static volatile gsize pomodoro_animation_mode_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_animation_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{POMODORO_ANIMATION_MODE_LINEAR, "POMODORO_ANIMATION_MODE_LINEAR", "linear"}, {POMODORO_ANIMATION_MODE_EASE_IN, "POMODORO_ANIMATION_MODE_EASE_IN", "ease-in"}, {POMODORO_ANIMATION_MODE_EASE_IN_OUT, "POMODORO_ANIMATION_MODE_EASE_IN_OUT", "ease-in-out"}, {POMODORO_ANIMATION_MODE_EASE_OUT, "POMODORO_ANIMATION_MODE_EASE_OUT", "ease-out"}, {POMODORO_ANIMATION_MODE_EASE_IN_CUBIC, "POMODORO_ANIMATION_MODE_EASE_IN_CUBIC", "ease-in-cubic"}, {POMODORO_ANIMATION_MODE_EASE_IN_OUT_CUBIC, "POMODORO_ANIMATION_MODE_EASE_IN_OUT_CUBIC", "ease-in-out-cubic"}, {POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC, "POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC", "ease-out-cubic"}, {POMODORO_ANIMATION_MODE_BLINK, "POMODORO_ANIMATION_MODE_BLINK", "blink"}, {0, NULL, NULL}};
		GType pomodoro_animation_mode_type_id;
		pomodoro_animation_mode_type_id = g_enum_register_static ("PomodoroAnimationMode", values);
		g_once_init_leave (&pomodoro_animation_mode_type_id__volatile, pomodoro_animation_mode_type_id);
	}
	return pomodoro_animation_mode_type_id__volatile;
}


static void __lambda5_ (PomodoroAnimation* self) {
	gdouble _tmp0_ = 0.0;
	_tmp0_ = self->priv->_progress;
	if (_tmp0_ == 1.0) {
		g_signal_emit_by_name (self, "complete");
	}
}


static void ___lambda5__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	__lambda5_ ((PomodoroAnimation*) self);
}


PomodoroAnimation* pomodoro_animation_construct (GType object_type, PomodoroAnimationMode mode, guint duration, guint frames_per_second) {
	PomodoroAnimation * self = NULL;
	guint _tmp0_ = 0U;
	PomodoroAnimationMode _tmp1_ = 0;
	guint _tmp2_ = 0U;
	guint _tmp3_ = 0U;
	_tmp0_ = frames_per_second;
	_vala_return_val_if_fail (_tmp0_ > ((guint) 0), "frames_per_second > 0", NULL);
	_tmp1_ = mode;
	_tmp2_ = duration;
	_tmp3_ = frames_per_second;
	self = (PomodoroAnimation*) g_object_new (object_type, "mode", _tmp1_, "duration", _tmp2_, "frames-per-second", _tmp3_, NULL);
	g_signal_connect_object ((GObject*) self, "notify::progress", (GCallback) ___lambda5__g_object_notify, self, 0);
	return self;
}


PomodoroAnimation* pomodoro_animation_new (PomodoroAnimationMode mode, guint duration, guint frames_per_second) {
	return pomodoro_animation_construct (POMODORO_TYPE_ANIMATION, mode, duration, frames_per_second);
}


void pomodoro_animation_add_property (PomodoroAnimation* self, GObject* target, const gchar* property_name, GValue* property_value) {
	GObject* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (target != NULL);
	g_return_if_fail (property_name != NULL);
	g_return_if_fail (property_value != NULL);
	_tmp0_ = target;
	pomodoro_animation_set_target (self, _tmp0_);
	_tmp1_ = property_name;
	pomodoro_animation_set_property_name (self, _tmp1_);
	_tmp2_ = g_value_get_double (property_value);
	self->priv->value_to = _tmp2_;
}


void pomodoro_animation_start (PomodoroAnimation* self) {
	GValue begin_value = {0};
	GValue _tmp0_ = {0};
	GObject* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	PomodoroAnimationMode _tmp4_ = 0;
	void* _tmp5_ = NULL;
	GDestroyNotify _tmp6_ = NULL;
	PomodoroAnimationFunc _tmp7_ = NULL;
	gint64 _tmp8_ = 0LL;
	guint _tmp9_ = 0U;
	gboolean _tmp11_ = FALSE;
	guint _tmp12_ = 0U;
	g_return_if_fail (self != NULL);
	g_value_init (&_tmp0_, G_TYPE_DOUBLE);
	begin_value = _tmp0_;
	_tmp1_ = self->priv->_target;
	_tmp2_ = self->priv->_property_name;
	g_object_get_property (_tmp1_, _tmp2_, &begin_value);
	_tmp3_ = g_value_get_double (&begin_value);
	self->priv->value_from = _tmp3_;
	_tmp4_ = self->priv->_mode;
	_tmp7_ = pomodoro_animation_get_func (_tmp4_, &_tmp5_, &_tmp6_);
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	self->priv->func = _tmp7_;
	self->priv->func_target = _tmp5_;
	self->priv->func_target_destroy_notify = _tmp6_;
	_tmp8_ = g_get_real_time ();
	self->priv->timestamp = _tmp8_ / 1000;
	_tmp9_ = self->priv->timeout_id;
	if (_tmp9_ != ((guint) 0)) {
		guint _tmp10_ = 0U;
		_tmp10_ = self->priv->timeout_id;
		g_source_remove (_tmp10_);
		self->priv->timeout_id = (guint) 0;
	}
	_tmp12_ = self->priv->_duration;
	if (_tmp12_ > ((guint) 0)) {
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		_tmp13_ = self->priv->value_from;
		_tmp14_ = self->priv->value_to;
		_tmp11_ = _tmp13_ != _tmp14_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		guint _tmp15_ = 0U;
		guint _tmp16_ = 0U;
		guint _tmp17_ = 0U;
		guint _tmp18_ = 0U;
		_tmp15_ = self->priv->_frames_per_second;
		_tmp16_ = self->priv->_duration;
		_tmp17_ = MIN (1000 / _tmp15_, _tmp16_);
		_tmp18_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp17_, (GSourceFunc) pomodoro_animation_on_timeout, g_object_ref (self), NULL);
		self->priv->timeout_id = _tmp18_;
		pomodoro_animation_set_progress (self, 0.0);
	} else {
		pomodoro_animation_set_progress (self, 1.0);
	}
	G_IS_VALUE (&begin_value) ? (g_value_unset (&begin_value), NULL) : NULL;
}


void pomodoro_animation_start_with_value (PomodoroAnimation* self, gdouble value_from) {
	gdouble _tmp0_ = 0.0;
	PomodoroAnimationMode _tmp1_ = 0;
	void* _tmp2_ = NULL;
	GDestroyNotify _tmp3_ = NULL;
	PomodoroAnimationFunc _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	guint _tmp6_ = 0U;
	guint _tmp8_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value_from;
	self->priv->value_from = _tmp0_;
	_tmp1_ = self->priv->_mode;
	_tmp4_ = pomodoro_animation_get_func (_tmp1_, &_tmp2_, &_tmp3_);
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	self->priv->func = _tmp4_;
	self->priv->func_target = _tmp2_;
	self->priv->func_target_destroy_notify = _tmp3_;
	_tmp5_ = g_get_real_time ();
	self->priv->timestamp = _tmp5_ / 1000;
	_tmp6_ = self->priv->timeout_id;
	if (_tmp6_ != ((guint) 0)) {
		guint _tmp7_ = 0U;
		_tmp7_ = self->priv->timeout_id;
		g_source_remove (_tmp7_);
		self->priv->timeout_id = (guint) 0;
	}
	_tmp8_ = self->priv->_duration;
	if (_tmp8_ > ((guint) 0)) {
		guint _tmp9_ = 0U;
		guint _tmp10_ = 0U;
		guint _tmp11_ = 0U;
		guint _tmp12_ = 0U;
		_tmp9_ = self->priv->_frames_per_second;
		_tmp10_ = self->priv->_duration;
		_tmp11_ = MIN (1000 / _tmp9_, _tmp10_);
		_tmp12_ = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp11_, (GSourceFunc) pomodoro_animation_on_timeout, g_object_ref (self), NULL);
		self->priv->timeout_id = _tmp12_;
		pomodoro_animation_set_progress (self, 0.0);
	} else {
		pomodoro_animation_set_progress (self, 1.0);
	}
}


void pomodoro_animation_stop (PomodoroAnimation* self) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timeout_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_ = 0U;
		_tmp1_ = self->priv->timeout_id;
		g_source_remove (_tmp1_);
		self->priv->timeout_id = (guint) 0;
	}
}


static gdouble pomodoro_animation_compute_value (PomodoroAnimation* self, gdouble progress) {
	gdouble result = 0.0;
	gdouble factor = 0.0;
	PomodoroAnimationFunc _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->func;
	_tmp0__target = self->priv->func_target;
	_tmp1_ = progress;
	_tmp2_ = CLAMP (_tmp1_, 0.0, 1.0);
	_tmp3_ = _tmp0_ (_tmp2_, _tmp0__target);
	factor = _tmp3_;
	_tmp4_ = self->priv->value_from;
	_tmp5_ = self->priv->value_to;
	_tmp6_ = self->priv->value_from;
	result = _tmp4_ + (factor * (_tmp5_ - _tmp6_));
	return result;
}


static gboolean pomodoro_animation_on_timeout (PomodoroAnimation* self) {
	gboolean result = FALSE;
	gint64 current_timestamp = 0LL;
	gint64 _tmp0_ = 0LL;
	gdouble _tmp1_ = 0.0;
	guint _tmp2_ = 0U;
	GObject* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GValue _tmp11_ = {0};
	gdouble _tmp12_ = 0.0;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = g_get_real_time ();
	current_timestamp = _tmp0_ / 1000;
	_tmp2_ = self->priv->_duration;
	if (_tmp2_ > ((guint) 0)) {
		gint64 _tmp3_ = 0LL;
		gint64 _tmp4_ = 0LL;
		guint _tmp5_ = 0U;
		gdouble _tmp6_ = 0.0;
		_tmp3_ = current_timestamp;
		_tmp4_ = self->priv->timestamp;
		_tmp5_ = self->priv->_duration;
		_tmp6_ = CLAMP (((gdouble) (_tmp3_ - _tmp4_)) / _tmp5_, 0.0, 1.0);
		_tmp1_ = _tmp6_;
	} else {
		_tmp1_ = 1.0;
	}
	pomodoro_animation_set_progress (self, _tmp1_);
	_tmp7_ = self->priv->_target;
	_tmp8_ = self->priv->_property_name;
	_tmp9_ = self->priv->_progress;
	_tmp10_ = pomodoro_animation_compute_value (self, _tmp9_);
	g_value_init (&_tmp11_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp11_, _tmp10_);
	g_object_set_property (_tmp7_, _tmp8_, &_tmp11_);
	G_IS_VALUE (&_tmp11_) ? (g_value_unset (&_tmp11_), NULL) : NULL;
	_tmp12_ = self->priv->_progress;
	if (_tmp12_ == 1.0) {
		self->priv->timeout_id = (guint) 0;
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


static gdouble _pomodoro_animation_calculate_linear_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_linear (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_in_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_in (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_in_out_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_in_out (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_out_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_out (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_in_cubic_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_in_cubic (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_in_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_in_out_cubic (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_ease_out_cubic_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_ease_out_cubic (progress);
	return result;
}


static gdouble _pomodoro_animation_calculate_blink_pomodoro_animation_func (gdouble progress, gpointer self) {
	gdouble result;
	result = pomodoro_animation_calculate_blink (progress);
	return result;
}


static PomodoroAnimationFunc pomodoro_animation_get_func (PomodoroAnimationMode mode, void** result_target, GDestroyNotify* result_target_destroy_notify) {
	PomodoroAnimationFunc result = NULL;
	PomodoroAnimationMode _tmp0_ = 0;
	PomodoroAnimationFunc _tmp9_ = NULL;
	void* _tmp9__target = NULL;
	GDestroyNotify _tmp9__target_destroy_notify = NULL;
	_tmp0_ = mode;
	switch (_tmp0_) {
		case POMODORO_ANIMATION_MODE_LINEAR:
		{
			PomodoroAnimationFunc _tmp1_ = NULL;
			void* _tmp1__target = NULL;
			GDestroyNotify _tmp1__target_destroy_notify = NULL;
			_tmp1_ = _pomodoro_animation_calculate_linear_pomodoro_animation_func;
			_tmp1__target = NULL;
			_tmp1__target_destroy_notify = NULL;
			*result_target = _tmp1__target;
			*result_target_destroy_notify = _tmp1__target_destroy_notify;
			result = _tmp1_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN:
		{
			PomodoroAnimationFunc _tmp2_ = NULL;
			void* _tmp2__target = NULL;
			GDestroyNotify _tmp2__target_destroy_notify = NULL;
			_tmp2_ = _pomodoro_animation_calculate_ease_in_pomodoro_animation_func;
			_tmp2__target = NULL;
			_tmp2__target_destroy_notify = NULL;
			*result_target = _tmp2__target;
			*result_target_destroy_notify = _tmp2__target_destroy_notify;
			result = _tmp2_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN_OUT:
		{
			PomodoroAnimationFunc _tmp3_ = NULL;
			void* _tmp3__target = NULL;
			GDestroyNotify _tmp3__target_destroy_notify = NULL;
			_tmp3_ = _pomodoro_animation_calculate_ease_in_out_pomodoro_animation_func;
			_tmp3__target = NULL;
			_tmp3__target_destroy_notify = NULL;
			*result_target = _tmp3__target;
			*result_target_destroy_notify = _tmp3__target_destroy_notify;
			result = _tmp3_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_OUT:
		{
			PomodoroAnimationFunc _tmp4_ = NULL;
			void* _tmp4__target = NULL;
			GDestroyNotify _tmp4__target_destroy_notify = NULL;
			_tmp4_ = _pomodoro_animation_calculate_ease_out_pomodoro_animation_func;
			_tmp4__target = NULL;
			_tmp4__target_destroy_notify = NULL;
			*result_target = _tmp4__target;
			*result_target_destroy_notify = _tmp4__target_destroy_notify;
			result = _tmp4_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN_CUBIC:
		{
			PomodoroAnimationFunc _tmp5_ = NULL;
			void* _tmp5__target = NULL;
			GDestroyNotify _tmp5__target_destroy_notify = NULL;
			_tmp5_ = _pomodoro_animation_calculate_ease_in_cubic_pomodoro_animation_func;
			_tmp5__target = NULL;
			_tmp5__target_destroy_notify = NULL;
			*result_target = _tmp5__target;
			*result_target_destroy_notify = _tmp5__target_destroy_notify;
			result = _tmp5_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_IN_OUT_CUBIC:
		{
			PomodoroAnimationFunc _tmp6_ = NULL;
			void* _tmp6__target = NULL;
			GDestroyNotify _tmp6__target_destroy_notify = NULL;
			_tmp6_ = _pomodoro_animation_calculate_ease_in_out_cubic_pomodoro_animation_func;
			_tmp6__target = NULL;
			_tmp6__target_destroy_notify = NULL;
			*result_target = _tmp6__target;
			*result_target_destroy_notify = _tmp6__target_destroy_notify;
			result = _tmp6_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_EASE_OUT_CUBIC:
		{
			PomodoroAnimationFunc _tmp7_ = NULL;
			void* _tmp7__target = NULL;
			GDestroyNotify _tmp7__target_destroy_notify = NULL;
			_tmp7_ = _pomodoro_animation_calculate_ease_out_cubic_pomodoro_animation_func;
			_tmp7__target = NULL;
			_tmp7__target_destroy_notify = NULL;
			*result_target = _tmp7__target;
			*result_target_destroy_notify = _tmp7__target_destroy_notify;
			result = _tmp7_;
			return result;
		}
		case POMODORO_ANIMATION_MODE_BLINK:
		{
			PomodoroAnimationFunc _tmp8_ = NULL;
			void* _tmp8__target = NULL;
			GDestroyNotify _tmp8__target_destroy_notify = NULL;
			_tmp8_ = _pomodoro_animation_calculate_blink_pomodoro_animation_func;
			_tmp8__target = NULL;
			_tmp8__target_destroy_notify = NULL;
			*result_target = _tmp8__target;
			*result_target_destroy_notify = _tmp8__target_destroy_notify;
			result = _tmp8_;
			return result;
		}
		default:
		break;
	}
	_tmp9_ = _pomodoro_animation_calculate_linear_pomodoro_animation_func;
	_tmp9__target = NULL;
	_tmp9__target_destroy_notify = NULL;
	*result_target = _tmp9__target;
	*result_target_destroy_notify = _tmp9__target_destroy_notify;
	result = _tmp9_;
	return result;
}


static gdouble pomodoro_animation_calculate_linear (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	_tmp0_ = t;
	result = _tmp0_;
	return result;
}


static gdouble pomodoro_animation_calculate_ease_in (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	result = _tmp0_ * _tmp1_;
	return result;
}


static gdouble pomodoro_animation_calculate_ease_in_out (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = t;
	t = _tmp0_ * 2.0;
	_tmp1_ = t;
	if (_tmp1_ < 1.0) {
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		_tmp2_ = t;
		_tmp3_ = t;
		result = (0.5 * _tmp2_) * _tmp3_;
		return result;
	} else {
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		_tmp4_ = t;
		t = _tmp4_ - 1.0;
		_tmp5_ = t;
		_tmp6_ = t;
		result = (-0.5) * ((_tmp5_ * (_tmp6_ - 2.0)) - 1.0);
		return result;
	}
}


static gdouble pomodoro_animation_calculate_ease_in_out_cubic (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	_tmp3_ = t;
	result = ((1.0 - _tmp0_) + (2.0 - _tmp1_)) * (_tmp2_ * _tmp3_);
	return result;
}


static gdouble pomodoro_animation_calculate_ease_out (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	result = (2.0 - _tmp0_) * _tmp1_;
	return result;
}


static gdouble pomodoro_animation_calculate_ease_in_cubic (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	result = (_tmp0_ * _tmp1_) * _tmp2_;
	return result;
}


static gdouble pomodoro_animation_calculate_ease_out_cubic (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	_tmp0_ = t;
	_tmp1_ = t;
	_tmp2_ = t;
	result = (((_tmp0_ - 3.0) * _tmp1_) + 3.0) * _tmp2_;
	return result;
}


static gdouble pomodoro_animation_calculate_blink (gdouble t) {
	gdouble result = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	_tmp1_ = t;
	if (_tmp1_ < 0.5) {
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		_tmp2_ = t;
		_tmp3_ = pomodoro_animation_calculate_ease_in_out (2.0 * _tmp2_);
		_tmp0_ = _tmp3_;
	} else {
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		_tmp4_ = t;
		_tmp5_ = pomodoro_animation_calculate_ease_in_out ((2.0 * _tmp4_) - 1.0);
		_tmp0_ = 1.0 - _tmp5_;
	}
	result = _tmp0_;
	return result;
}


GObject* pomodoro_animation_get_target (PomodoroAnimation* self) {
	GObject* result;
	GObject* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_target;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void pomodoro_animation_set_target (PomodoroAnimation* self, GObject* value) {
	GObject* _tmp0_ = NULL;
	GObject* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_target);
	self->priv->_target = _tmp1_;
	g_object_notify ((GObject *) self, "target");
}


const gchar* pomodoro_animation_get_property_name (PomodoroAnimation* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_property_name;
	result = _tmp0_;
	return result;
}


void pomodoro_animation_set_property_name (PomodoroAnimation* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_property_name);
	self->priv->_property_name = _tmp1_;
	g_object_notify ((GObject *) self, "property-name");
}


PomodoroAnimationMode pomodoro_animation_get_mode (PomodoroAnimation* self) {
	PomodoroAnimationMode result;
	PomodoroAnimationMode _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_mode;
	result = _tmp0_;
	return result;
}


void pomodoro_animation_set_mode (PomodoroAnimation* self, PomodoroAnimationMode value) {
	PomodoroAnimationMode _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_mode = _tmp0_;
	g_object_notify ((GObject *) self, "mode");
}


guint pomodoro_animation_get_duration (PomodoroAnimation* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_duration;
	result = _tmp0_;
	return result;
}


void pomodoro_animation_set_duration (PomodoroAnimation* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_duration = _tmp0_;
	g_object_notify ((GObject *) self, "duration");
}


guint pomodoro_animation_get_frames_per_second (PomodoroAnimation* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_frames_per_second;
	result = _tmp0_;
	return result;
}


void pomodoro_animation_set_frames_per_second (PomodoroAnimation* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_frames_per_second = _tmp0_;
	g_object_notify ((GObject *) self, "frames-per-second");
}


gdouble pomodoro_animation_get_progress (PomodoroAnimation* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_progress;
	result = _tmp0_;
	return result;
}


static void pomodoro_animation_set_progress (PomodoroAnimation* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_progress = _tmp0_;
	g_object_notify ((GObject *) self, "progress");
}


static void pomodoro_animation_class_init (PomodoroAnimationClass * klass) {
	pomodoro_animation_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroAnimationPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_animation_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_animation_set_property;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_animation_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_TARGET, g_param_spec_object ("target", "target", "target", G_TYPE_OBJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_PROPERTY_NAME, g_param_spec_string ("property-name", "property-name", "property-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_MODE, g_param_spec_enum ("mode", "mode", "mode", POMODORO_TYPE_ANIMATION_MODE, POMODORO_ANIMATION_MODE_LINEAR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_DURATION, g_param_spec_uint ("duration", "duration", "duration", 0, G_MAXUINT, (guint) 200, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_FRAMES_PER_SECOND, g_param_spec_uint ("frames-per-second", "frames-per-second", "frames-per-second", 0, G_MAXUINT, (guint) 60, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), POMODORO_ANIMATION_PROGRESS, g_param_spec_double ("progress", "progress", "progress", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("complete", POMODORO_TYPE_ANIMATION, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void pomodoro_animation_instance_init (PomodoroAnimation * self) {
	self->priv = POMODORO_ANIMATION_GET_PRIVATE (self);
	self->priv->_mode = POMODORO_ANIMATION_MODE_LINEAR;
	self->priv->_duration = (guint) 200;
	self->priv->_frames_per_second = (guint) 60;
	self->priv->_progress = 0.0;
	self->priv->timestamp = (gint64) 0;
	self->priv->timeout_id = (guint) 0;
	self->priv->func = NULL;
}


static void pomodoro_animation_finalize (GObject* obj) {
	PomodoroAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_ANIMATION, PomodoroAnimation);
	pomodoro_animation_stop (self);
	_g_object_unref0 (self->priv->_target);
	_g_free0 (self->priv->_property_name);
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	G_OBJECT_CLASS (pomodoro_animation_parent_class)->finalize (obj);
}


GType pomodoro_animation_get_type (void) {
	static volatile gsize pomodoro_animation_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_animation_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroAnimationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_animation_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroAnimation), 0, (GInstanceInitFunc) pomodoro_animation_instance_init, NULL };
		GType pomodoro_animation_type_id;
		pomodoro_animation_type_id = g_type_register_static (G_TYPE_INITIALLY_UNOWNED, "PomodoroAnimation", &g_define_type_info, 0);
		g_once_init_leave (&pomodoro_animation_type_id__volatile, pomodoro_animation_type_id);
	}
	return pomodoro_animation_type_id__volatile;
}


static void _vala_pomodoro_animation_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ANIMATION, PomodoroAnimation);
	switch (property_id) {
		case POMODORO_ANIMATION_TARGET:
		g_value_set_object (value, pomodoro_animation_get_target (self));
		break;
		case POMODORO_ANIMATION_PROPERTY_NAME:
		g_value_set_string (value, pomodoro_animation_get_property_name (self));
		break;
		case POMODORO_ANIMATION_MODE:
		g_value_set_enum (value, pomodoro_animation_get_mode (self));
		break;
		case POMODORO_ANIMATION_DURATION:
		g_value_set_uint (value, pomodoro_animation_get_duration (self));
		break;
		case POMODORO_ANIMATION_FRAMES_PER_SECOND:
		g_value_set_uint (value, pomodoro_animation_get_frames_per_second (self));
		break;
		case POMODORO_ANIMATION_PROGRESS:
		g_value_set_double (value, pomodoro_animation_get_progress (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_animation_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroAnimation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_ANIMATION, PomodoroAnimation);
	switch (property_id) {
		case POMODORO_ANIMATION_TARGET:
		pomodoro_animation_set_target (self, g_value_get_object (value));
		break;
		case POMODORO_ANIMATION_PROPERTY_NAME:
		pomodoro_animation_set_property_name (self, g_value_get_string (value));
		break;
		case POMODORO_ANIMATION_MODE:
		pomodoro_animation_set_mode (self, g_value_get_enum (value));
		break;
		case POMODORO_ANIMATION_DURATION:
		pomodoro_animation_set_duration (self, g_value_get_uint (value));
		break;
		case POMODORO_ANIMATION_FRAMES_PER_SECOND:
		pomodoro_animation_set_frames_per_second (self, g_value_get_uint (value));
		break;
		case POMODORO_ANIMATION_PROGRESS:
		pomodoro_animation_set_progress (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



